package shapecalculus.behaviour;

import java.util.Iterator;

import shapecalculus.BasicShape;
import shapecalculus.behaviour.channel.Channel;

public class Kill extends AtomicBehaviour {

	private BasicShape shape;
	private BasicShape victim;

	public Kill(BasicShape shape, BasicShape victim) {
		this.shape = shape;
		this.victim = victim;
	}

	@Override
	public int perform(Iterator<Integer> path) {
		Channel chan;
		for (int i = 0; i < 6; i++) {
			chan = this.victim.getSurfaceAt(i);
			if (chan != null) {
				chan.getBindedTo().removeBond();
				chan.removeBond();
			}
		}
		this.victim.getContext().remove(this.victim);
		return 0;
	}

	@Override
	public boolean canPerform() {
		return true;
	}

	@Override
	public BasicShape getShape() {
		return this.shape;
	}

	@Override
	public Object clone() {
		Kill d = new Kill(this.shape, this.victim);
		d.initPath(this.path);
		return d;
	}

}
