package shapecalculus.boneremodelling;

import java.util.Iterator;

import shapecalculus.BasicShape;
import shapecalculus.behaviour.AtomicBehaviour;

public class ActivateKiller extends AtomicBehaviour {

	private BasicShape caller;
	private ShapeKiller[] killers;

	public ActivateKiller(BasicShape caller, ShapeKiller... killers) {
		this.caller = caller;
		this.killers = killers;
	}

	@Override
	public int perform(Iterator<Integer> path) {
		for (ShapeKiller killer : this.killers)
			killer.activateKiller();
		return 0;
	}

	@Override
	public boolean canPerform() {
		return true;
	}

	@Override
	public BasicShape getShape() {
		return this.caller;
	}

	@Override
	public Object clone() {
		return new ActivateKiller(caller, killers);
	}

}
