package shapecalculus.boneremodelling;

import repast.simphony.space.continuous.NdPoint;

public class Attraction {

	private double[] point;
	private double[] weight;

	public Attraction() {
		this.point = new double[3];
		this.weight = new double[2];
	}

	public void insertPoint(double[] weight, double... coords) {
		for (int i = 0; i < weight.length; i++)
			this.weight[i] += weight[i];
		for (int i = 0; i < coords.length; i++)
			point[i] += coords[i];
	}

	public void reset() {
		this.point = new double[3];
		this.weight = new double[2];
	}

	public NdPoint getVelocity(NdPoint position) {
		if (weight[0] > 0) {
			double x = point[0] / weight[0] - position.getX();
			double y = point[1] / weight[1] - position.getY();
			return new NdPoint(x, y, 0);
		}
		return new NdPoint(0, 0, 0);
	}
}
