package shapecalculus.boneremodelling;

import repast.simphony.random.RandomHelper;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridAdder;
import repast.simphony.space.grid.GridDimensions;
import repast.simphony.space.grid.GridPoint;
import repast.simphony.util.ContextUtils;
import repast.simphony.valueLayer.GridValueLayer;
import shapecalculus.Shape;

public class BMUGridAdder_old<T> implements GridAdder<T> {

	@Override
	public void add(Grid<T> space, T obj) {

		GridDimensions dims = space.getDimensions();
		int[] location = new int[dims.size()];
		if (!(obj instanceof Osteocyte)
				|| BRContext.fracture.getNextFreePoint() != null) {

			findLocation(location, dims, obj);

			while (!space.moveTo(obj, location))
				findLocation(location, dims, obj);

			if (obj instanceof Shape)
				((Shape) obj).setDiscretePosition(new GridPoint(location));

			if (obj instanceof Osteocyte) {
				BRContext.fracture.setOccupied(new GridPoint(location), true);
				GridValueLayer bonemass = (GridValueLayer) ContextUtils
						.getContext(obj).getValueLayer("BoneMass");
				bonemass.set(0, location[0], location[1]);
			}

		}
	}

	private void findLocation(int[] location, GridDimensions dims, T obj) {
		int[] origin = dims.originToIntArray(null);
		if (obj instanceof Osteoblast || obj instanceof Osteoclast) {
			location[0] = 0;
			location[1] = RandomHelper.getUniform().nextIntFromTo(0,
					dims.getDimension(1) - origin[1] - 1);
//			location[1]=(int) (dims.getDimension(1)/2 +Math.random()*2 -1);
			if (location.length > 2)
				location[2] = 0;
		} else if (obj instanceof Osteocyte)
			BRContext.fracture.getNextFreePoint().toIntArray(location);
		else if(obj instanceof BoneNode){
			int[] coords=((BoneNode) obj).getCoords();
			location[0]=coords[0];
			location[1]=coords[1];
//			location[2]=0;
		}
		else {
			location[0] = 0;
			location[1] = 0;
//			if (location.length > 2)
//				location[2] = 0;
		}

	}
}
