package shapecalculus.boneremodelling;

import java.awt.Color;
import java.awt.Font;

import javax.media.j3d.Shape3D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;

import repast.simphony.visualization.visualization3D.AppearanceFactory;
import repast.simphony.visualization.visualization3D.ShapeFactory;
import repast.simphony.visualization.visualization3D.style.Style3D;
import repast.simphony.visualization.visualization3D.style.TaggedAppearance;
import repast.simphony.visualization.visualization3D.style.TaggedBranchGroup;

/**
 * Style for grass in 3D displays
 * 
 * @author Eric Tatara
 * @author Nick Collier
 */
public class BoneNodeStyle implements Style3D<Object> {

	public TaggedBranchGroup getBranchGroup(Object agent,
			TaggedBranchGroup taggedGroup) {

		if (taggedGroup == null || taggedGroup.getTag() == null) {
			taggedGroup = new TaggedBranchGroup("DEFAULT");
			Shape3D cube = ShapeFactory.createCube(.03f, "DEFAULT");

			Transform3D trans = new Transform3D();
			trans.set(new Vector3f(0, 0, -.05f));
			trans.setScale(new Vector3d(1, 1, 0.5));
			TransformGroup grp = new TransformGroup(trans);

			grp.addChild(cube);
			taggedGroup.getBranchGroup().addChild(grp);

			return taggedGroup;
		}
		return null;
	}

	public float[] getRotation(Object o) {
		return null;
	}

	public String getLabel(Object o, String currentLabel) {
		return null; // return currentLabel.length() > 0 ? currentLabel :
						// String.valueOf(o.getId());
		// return o.toString();
	}

	public Color getLabelColor(Object t, Color currentColor) {
		return Color.YELLOW;
	}

	public Font getLabelFont(Object t, Font currentFont) {
		return null;
	}

	public LabelPosition getLabelPosition(Object o, LabelPosition curentPosition) {
		return LabelPosition.NORTH;
	}

	public float getLabelOffset(Object t) {
		return .035f;
	}

	public TaggedAppearance getAppearance(Object agent,
			TaggedAppearance taggedAppearance, Object shapeID) {
		if (taggedAppearance == null) {
			taggedAppearance = new TaggedAppearance();
		}
		if (agent instanceof BoneNode) {
			BoneNode bonecell = (BoneNode) agent;
			double value = bonecell.getValue();
			AppearanceFactory.setMaterialAppearance(taggedAppearance
					.getAppearance(), new Color(255, (int) (value * 2.55),
					(int) (value * 2.55)));
			// (int) (value * 2.55), (int) (value * 2.55)));
		}
		// AppearanceFactory.setTransparentAppearance(taggedAppearance.getAppearance(),
		// TransparencyAttributes.SCREEN_DOOR, 0.5f);

		return taggedAppearance;

	}

	public float[] getScale(Object o) {
		return null;
	}
}
