package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import shapecalculus.BasicShape;
import shapecalculus.behaviour.Behaviour;

public class Cell extends BasicShape {

	private int life;

	public Cell(double mass, Context context, Grid<Object> grid,
			ContinuousSpace<Object> space, Behaviour behaviour) {
		super(mass, context, grid, space, behaviour);
		this.life = 50;
	}

	public int isOsteoblast() {
		return 0;
	}

	public int isOsteoclast() {
		return 0;
	}

	@ScheduledMethod(/* priority = ScheduleParameters.FIRST_PRIORITY, */start = 1, interval = 1)
	public void suicide() {
		if (life > 0)
			life--;
		else
			this.getContext().remove(this);
	}

}
