package shapecalculus.boneremodelling;

import java.util.ArrayList;
import java.util.List;

import repast.simphony.random.RandomHelper;
import repast.simphony.space.continuous.NdPoint;
import repast.simphony.util.SimUtilities;

public class MinAttraction {

	private double bestDistance;
	private List<NdPoint> points;

	public MinAttraction() {
		this.points = new ArrayList<NdPoint>();
		this.bestDistance = Double.MAX_VALUE;
	}

	public void insertPoint(double... coords) {
		if (coords[0] == bestDistance)
			points.add(new NdPoint(coords));
		else if (coords[0] < bestDistance) {
			bestDistance = coords[0];
			points.clear();
			points.add(new NdPoint(coords));
		}
	}

	public void reset() {
		this.points = new ArrayList<NdPoint>();
		this.bestDistance = Double.MAX_VALUE;
	}
	
	public boolean isEmpty(){
		return this.points.isEmpty();
	}

	
	public NdPoint getVelocity(NdPoint position) {
		if (this.points.size() > 0) {
			SimUtilities.shuffle(this.points, RandomHelper.getUniform());
			double x = this.bestDistance - position.getX();
			double y = this.points.get(0).getY() - position.getY();
			return new NdPoint(x, y, 0);
		}
		return new NdPoint(0, 0, 0);
	}
}
