package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.random.RandomHelper;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import shapecalculus.BasicShape;
import shapecalculus.behaviour.Behaviour;
import shapecalculus.behaviour.BehaviourException;
import shapecalculus.behaviour.Delay;
import shapecalculus.behaviour.Kill;
import shapecalculus.behaviour.Sequence;

public class OsteoblastKiller extends ShapeKiller {
	private BasicShape[] victims;

	public OsteoblastKiller(double mass, Context context, Grid<Object> grid,
			ContinuousSpace<Object> space, Behaviour behaviour,
			BasicShape... victims) {
		super(mass, context, grid, space, behaviour);
		this.victims = victims;
	}

	@Override
	public void updateVelocity() {
		
	}
	
	@Override
	public void activateKiller() {
		try {
			int lifeSpan = ParametersManager.getLifeSpan()[1];
			Behaviour[] b = new Behaviour[this.victims.length + 2];
//			BRContext context = (BRContext) this.getContext();
//			double ocInhibition = context.getOsteoclastCount()
//					/ ParametersManager.getMaximumCellNum()[0];

			double rate = RandomHelper.getUniform().nextDoubleFromTo(0,
					ParametersManager.getAgingFactor() - 1);
			lifeSpan -= (lifeSpan * rate) / 2;
			// double rate = RandomHelper.getUniform().nextDoubleFromTo(1,
			// ParametersManager.getAgingFactor());
			// lifeSpan=Math.max(1, (int) (lifeSpan/(ocInhibition*rate)));
			b[0] = new Delay(lifeSpan /** 10 */
			, this);
			b[this.victims.length + 1] = new Kill(this, this);
			for (int i = 0; i < this.victims.length; i++)
				b[i + 1] = new Kill(this, this.victims[i]);
			this.setBehaviour(new Sequence(b));
		} catch (BehaviourException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
