package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.random.RandomHelper;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.continuous.NdPoint;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;
import shapecalculus.ShapeException;
import shapecalculus.Surface;
import shapecalculus.behaviour.Behaviour;
import shapecalculus.behaviour.BehaviourException;
import shapecalculus.behaviour.Bind;
import shapecalculus.behaviour.Choice;
import shapecalculus.behaviour.Delay;
import shapecalculus.behaviour.Kill;
import shapecalculus.behaviour.Recursion;
import shapecalculus.behaviour.Sequence;
import shapecalculus.behaviour.Split;
import shapecalculus.behaviour.channel.OutChannel;

public class OsteoclastKiller extends ShapeKiller {

	private Osteoclast victim;

	public OsteoclastKiller(double mass, Context context, Grid<Object> grid,
			ContinuousSpace<Object> space, Behaviour behaviour,
			Osteoclast victim) {
		super(mass, context, grid, space, behaviour);
		this.victim = victim;

	}

	@Override
	public void activateKiller() {
		try {
			Behaviour[] bs = new Sequence[4];
			for (int i = 0; i < 4; i++)
				bs[i] = new Sequence(new Bind(new OutChannel("ob", this,
						new Surface(i), new GridPoint(1, 1, 1), 1)),
						new SetVelocity(this, new NdPoint(0, 0, 0)), new Split(
								new OutChannel("ob", this, new Surface(i),
										new GridPoint(1, 1, 1), 1)),
						new SetVelocity(this, new NdPoint(0, 0, 0)));
			int lifeSpan = ParametersManager.getLifeSpan()[0];
			// double rate=Math.log(BRContext.currentObNum+1);
			double rate = BRContext.currentObNum
					/ (BRContext.currentOcNum * 10);
			rate = RandomHelper.getUniform().nextDoubleFromTo(0, rate);
			lifeSpan -= rate;
			// int iterations = (int) (ParametersManager.getBoneFormation() /
			// ParametersManager
			// .getBoneResorption());
			// int iterations = 100;
			int iterations = 20;
			this.setBehaviour(new Sequence(new Delay(lifeSpan /** 10 */
			, this), new Kill(this, this.victim), new Recursion(new Choice(bs),
					iterations), new Kill(this, this)));
		} catch (ShapeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (BehaviourException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
