package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;
import shapecalculus.BasicShape;
import shapecalculus.ShapeException;
import shapecalculus.Surface;
import shapecalculus.behaviour.Behaviour;
import shapecalculus.behaviour.BehaviourException;
import shapecalculus.behaviour.Bind;
import shapecalculus.behaviour.Choice;
import shapecalculus.behaviour.Kill;
import shapecalculus.behaviour.Sequence;
import shapecalculus.behaviour.Split;
import shapecalculus.behaviour.channel.OutChannel;

public class Osteocyte extends BasicShape {

	public Osteocyte(double mass, Context context, Grid<Object> grid,
			ContinuousSpace<Object> space, Behaviour behaviour) {
		super(mass, context, grid, space, behaviour);
		try {
			Behaviour[] bs = new Sequence[4];
			int sens = ParametersManager.getFractureSensibility();
			for (int i = 0; i < 4; i++)
				bs[i] = new Sequence(new Bind(new OutChannel("rank'", this,
						new Surface(i), new GridPoint(sens, sens, 1), 1)),
				/* new SetVelocity(this, new NdPoint(0, 0, 0)), */new Split(
						new OutChannel("rank'", this, new Surface(i),
								new GridPoint(1, 1, 1), 1)), new Kill(this,
						this));
			// bs[i] = new Sequence(new CoConsume(new OutChannel("rank'", this,
			// new Surface(i), new GridPoint(1, 1, 1), 1)));
			this.setBehaviour(new Choice(bs));
		} catch (ShapeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (BehaviourException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
