package shapecalculus.boneremodelling;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

public class ParametersManager {

	public static int[] getBMUSize() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return new int[] {
				(int) (((Double) params.getValue("bmuWidth"))* 100),
//				(int) (((Double) params.getValue("bmuHeight"))* 100), 1 };
				(int) (((Double) params.getValue("bmuHeight"))* 100)};
	}
	
	public static String getFractureType(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (String) params.getValue("fractureType");
	}
	public static String getBoneType(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (String) params.getValue("boneType");
	}
	public static String getDensityPath(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (String) params.getValue("densityFile");
	}
	public static int getFractureSensibility() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Integer) params.getValue("oyDistance");
	}
	
	public static int getOPGSensibility() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Integer) params.getValue("OPGDistance");
	}
	
	public static double getFractureAttractionFactor(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("InflammatoryFactor")*50.0;
	}
	public static double getObAttractionFactor(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("InflammatoryFactor")*4.0;
	}
	public static double getInflammatoryFactor(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("InflammatoryFactor");
	}
	public static double getAgingFactor(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("AgingFactor");
	}
	
	public static double[] getMotionRandomness(){
		Parameters params = RunEnvironment.getInstance().getParameters();
		return new double[] { (Double) params.getValue("ocRandomMotion"),
				(Double) params.getValue("obRandomMotion") };
	}
	
//	public static double[] getDiffusionCoefficents() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return new double[] { (Double) params.getValue("dOc"),
//				(Double) params.getValue("dOb") };
//	}
	
	public static double getObDiffusionCoefficent() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("dOb");
	}

	public static int[] getMaximumCellNum() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		int[] ret = new int[2];
		ret[0] = (int) ((20 * (Double) params.getValue("bmuWidth") * (Double) params
				.getValue("bmuHeight")) / 3.84);
		ret[1] = (int) ((2000 * (Double) params.getValue("bmuWidth") * (Double) params
				.getValue("bmuHeight")) / 3.84);
		return ret;
	}

	public static double[] getFormationRates() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return new double[] { (Double) params.getValue("ocFormationRate"),
				(Double) params.getValue("obFormationRate") };
	}

	public static int[] getLifeSpan() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return new int[] { (Integer) params.getValue("ocLifeSpan"),
				(Integer) params.getValue("obLifeSpan") };
	}

//	public static double[] getAutocrine() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return new double[] { (Double) params.getValue("g11"),
//				(Double) params.getValue("g22") };
//	}
//
//	public static double[] getParacrine() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return new double[] { (Double) params.getValue("g12"),
//				(Double) params.getValue("g21") };
//	}

	public static double getBoneResorption() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("resorptionRate");
	}

	public static double getBoneFormation() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Double) params.getValue("formationRate");
	}

//	public static int getObRANKLTime() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return (Integer) params.getValue("obRankl");
//	}

	public static int getObOPGTime() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Integer) params.getValue("obOPG");
	}

	public static int getRANKLProductionRate() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Integer) params.getValue("aR");
	}

	public static int getOPGProductionRate() {
		Parameters params = RunEnvironment.getInstance().getParameters();
		return (Integer) params.getValue("aO");
	}

//	public static double getRANKLDiffusionRate() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return (Double) params.getValue("kR");
//	}
//
//	public static double getOPGDiffusionRate() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return (Double) params.getValue("kO");
//	}

//	public static double getViscosity() {
//		Parameters params = RunEnvironment.getInstance().getParameters();
//		return (2 - Math.pow(2, -(Double) params.getValue("epsilon")))/5;
//	}

//	public static double[] getSteadyState() {
//		double[] autocrine = getAutocrine();
//		double[] paracrine = getParacrine();
//		double g11 = autocrine[0];
//		double g22 = autocrine[1];
//		double g12 = paracrine[0];
//		double g21 = paracrine[1];
//		// we do not include Beta1 and Beta2, these are expectable ratio
//		// beta_i/alpha_i
//		double ratio1 = 0.033;
//		double ratio2 = 0.005;
//		double gamma = g12 * g21 + (g11 - 1) * (1 - g22);
//		double x1 = Math.pow(ratio1, (1 - g22) / gamma)
//				* Math.pow(ratio2, g21 / gamma);
//		double x2 = Math.pow(ratio1, g12 / gamma)
//				* Math.pow(ratio2, (1 - g11) / gamma);
//		return new double[] { x1, x2 };
//	}
}
