package shapecalculus.boneremodelling;

import java.util.Iterator;

import repast.simphony.space.continuous.NdPoint;
import shapecalculus.BasicShape;
import shapecalculus.behaviour.AtomicBehaviour;

public class SetVelocity extends AtomicBehaviour {

	private BasicShape shape;
	private NdPoint velocity;

	public SetVelocity(BasicShape shape, NdPoint velocity) {
		this.shape = shape;
		this.velocity = velocity;
	}

	@Override
	public int perform(Iterator<Integer> path) {
		this.shape.setVelocity(this.velocity);
		return 0;
	}

	@Override
	public boolean canPerform() {
		return true;
	}

	@Override
	public BasicShape getShape() {
		return this.shape;
	}

	@Override
	public Object clone() {
		return new SetVelocity(shape, velocity);
	}

}
